# Copyright 2007, TIG                                                         
# Permission to use, copy, modify, and distribute this software for           
# any purpose and without fee is hereby granted, provided that the above      
# copyright notice appear in all copies.                                      
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
# Name :        RandomDelete.rb
# Description : Randomly deletes entities in a selection.
# Use :         Select some entities and pick tool off menu.
#				Set % to be deleted in dialog.
#				Sit back and watch the carnage.
#				Use with care...
# Version :		20071203 First Issue
require 'sketchup.rb'
def randomDelete
  model=Sketchup.active_model; ss=model.selection
  (UI.messagebox("No Selection !"); return nil) if ! ss[0]
  model.start_operation "Random Delete"
  $rd_per=10.0 if not $rd_per
  rd_per,=inputbox(["% to be Deleted: "],[$rd_per],"Random Delete")
  return nil if not rd_per; $rd_per=rd_per
  ###$rd_per=1.0 if $rd_per <1.0; $rd_per=99.0 if $rd_per >99.0###ranges
  ss.each{|e|e.erase! if e.valid? && $rd_per >= rand*100}
  model.selection.clear
  model.commit_operation
end
is_me=__FILE__
UI.menu("Plugins").add_item("Random Delete - Use with Care !"){randomDelete} if not file_loaded?(is_me)
file_loaded(is_me)
